<template>
    <div class="container">
      <h3>Activos</h3>
  
      <div class="card">
        <div class="card-content">
          <form @submit.prevent="nuevo()">
            <h5>Nuevo Activo</h5>
            <p>Tipo de Activo: <input type="text" v-model="payload.tipo_activo" required /></p>
            <p>Marca: <input type="text" v-model="payload.marca" required /></p>
            <p>Modelo: <input type="text" v-model="payload.modelo" required /></p>
            <p>
                <select v-model="payload.estado" required>
                    <option value="Nuevo">Nuevo</option>
                    <option value="Usado">Usado</option>
                    <option value="En Desuso">En Desuso</option>
                </select>
            </p>
            <p v-if="areas.length > 0">
                <select v-model="payload.areaId" required>
                    <option :value="area.id" v-for="area in areas">{{area.nombre}}</option>
                </select>
            </p>
            <button type="submit" class="waves-effect maves-light btn-small">Agregar</button>
          </form>
        </div>
      </div>
  
      <div class="card">
        <div class="card-content">
          <form @submit.prevent="getList()">
            <h5>Buscar Activo</h5>
            <p>Tipo de Activo: <input type="search" v-model="search" @search="getList()" /></p>
            <button type="submit" class="waves-effect maves-light btn-small">Buscar</button>
          </form>
        </div>
      </div>
  
      <div class="card">
        <div class="card-content">
          <h5>Filtros</h5>
          <div class="input-field">
            <select @change="filter('estado', $event.target.value)">
                <option value="">- Todos -</option>
                <option value="Nuevo">Nuevo</option>
                <option value="Usado">Usado</option>
                <option value="En Desuso">En Desuso</option>
            </select>
            <label>Materialize Select</label>
          </div>
        </div>
      </div>
  
      <div class="card">
        <div class="card-content">
          <table>
            <thead>
              <tr>
                  <th>Id</th>
                  <th>Tipo de Activo</th>
                  <th>Marca</th>
                  <th>Modelo</th>
                  <th>Estado</th>
                  <th>&Aacute;rea</th>
                  <th></th>
                  <th></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in items">
                <td>{{item.id}}</td>
                <td>{{item.tipo_activo}}</td>
                <td>{{item.marca}}</td>
                <td>{{item.modelo}}</td>
                <td>{{item.estado}}</td>
                <td>{{item.area.nombre}}</td>
                <td><a class="btn-floating btn-large waves-effect waves-light red"><i class="material-icons" @click="eliminar(item.id)">delete</i></a></td>
                <td><a class="btn-floating btn-large waves-effect waves-light blue"><i class="material-icons" @click="update(item.id)">edit</i></a></td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </template>
  
  <script>
  
  export default {
    name: 'ActivoView',
    data(){
      const api = process.env.VUE_APP_API;
      return {
        api,
        items:[],
        search: '',
        toFilter: '',
        areas: [],
        payload:{
          tipo_activo:null,
          marca: null,
          modelo: null,
          estado: null,
          areaId: null
        }
      }
    },
    methods: {
      filter(name, value) {
        this.toFilter = value === '' ? '' : '&' + name + '=' + value;
        this.getList();
      },
      update(id){
        this.$router.push('/activo/'+id);
      },
      eliminar(id){
        if(confirm("Esta seguro de eliminar este activo?")){
          this.axios({
            method: 'delete',
            url: this.api+'/activos/'+id
          }).
          then((response)=>{
            this.getList();
          }).
          catch((error)=>{
            console.log(error);
          });
        }
      },
      nuevo(){
        this.axios({
          method: 'post',
          url: this.api+'/activos',
          data: this.payload
        }).
        then((response)=>{
            this.getList();
            this.payload.tipo_activo = null;
            this.payload.marca = null;
            this.payload.modelo = null;
            this.payload.estado = null;
            this.payload.areaId = null;
            console.log(response);
        }).
        catch((error)=>{
          console.log(error);
        });
      },
      getList(name, value){
        this.axios({
          method: 'get',
          url: this.api+'/activos?_expand=area&q=' + this.search + this.toFilter
        }).
        then((response)=>{
          this.items = response.data;
        }).
        catch((error)=>{
          console.log(error);
        })
      },
      getAreaList(){
        this.axios({
          method: 'get',
          url: this.api+'/areas'
        }).
        then((response)=>{
          this.areas = response.data;
          const intervalo = setTimeout(() => {
            this.intSelect();
            clearTimeout(intervalo);
          }, 4000);
        }).
        catch((error)=>{
          console.log(error);
        })
      },
      intSelect(){
        this.getList();
        this.getAreaList();
        var elems = document.querySelectorAll('select');
        var instances = M.FormSelect.init(elems);
      }
    },
    components: {
     
    },
    mounted(){
      this.getList();
      this.getAreaList();
      var elems = document.querySelectorAll('select');
      var instances = M.FormSelect.init(elems);
    }
  }
  </script>
  